/*
 * The contents of this file are
 * published under the Mozilla Public License 1.1
 */
//@@@@@@@@@@@@@@@@
function ASRDF_BaseParser		//<c>abstract<a>protected<d>Basic line parser class
(){
//================
this.ASRDF_BaseParser = function		//<m>void<a>private<d>class constructor
(){
this.className	= 'ASRDF_BaseParser';
//i12n
}//</m>ASRDF_BaseParser



//================
this.getError = function		//<m>Object<a>public<d>Get error descriptor
(
errorCode		//<p>int<d>Error code
){
return	{
	code:		errorCode,
	message:	this.K.ERROR_MSG[-errorCode -1]
	};
}//</m>getError



//================
this.testCodeLine = function		//<m>boolean<a>private<d>Check whether line is a blank line
(
line		//<p>string<d>Source line
){
return !this.testBlankLine(line) && !this.testCommentLine(line);
}//</m>testCodeLine



//================
this.testBlankLine = function		//<m>boolean<a>private<d>Check whether line is a blank line
(
line		//<p>string<d>Source line
){
return line == '';
}//</m>testBlankLine



//================
this.testCommentLine = function		//<m>boolean<a>private<d>Check whether line is a comment line
(
line		//<p>string<d>Source line
){
return line.match(this.K.COMMENT.LINE);
}//</m>testCommentLine



this.K =
	{
	COMMENT:
		{
		LINE:			/^#.*$/,
		DELIMITER:		/\s+#/
		},
	ERROR:
		{
		//NON FATAL
		NONE:					0,
		NO_SUCCESS:				1,
	
		//FATAL
		MISSING_SUBJECT:		-1,
		MISSING_PREDICATE:		-2,
		MISSING_OBJECT:			-3,
		MISSING_SUBJECT_RESOURCE:		-4,
		FATAL:					0xFF		//end of error codes
		},
	ERROR_MSG:
		[
		'Triple subject is missing',
		'Triple predicate is missing',
		'Triple object is missing',
		'Triple subject resource is missing'
		]
	};



this.ASRDF_BaseParser();
}//</c>ASRDF_BaseParser



