/*
 * The contents of this file are
 * published under the Mozilla Public License 1.1
 */
//@@@@@@@@@@@@@@@@
function ASRDF_OutlineParser		//<c><e>ASRDF_BaseParser<a>protected<d>Source line parser class
(){
//================
this.ASRDF_OutlineParser = function		//<m>void<a>private<d>class constructor
(){
this.className	= 'ASRDF_OutlineParser';
//i12n
this.level = 0;
this.step = this.K.STEP.INIT;
}//</m>ASRDF_OutlineParser



//================
this.getProcessor = function		//<m>Object<a>private<d>Get outline processing
(
code		//<p>string<d>Line code
){
var
/*int*/count = level = 0,
/*int*/step, changing;
while(code.charAt(count) == this.K.OUTLINE_CHAR) count++;
if(count > 2) level = (count - 1) >> 1;
step = (count + level) % 3;
return {
	count:	count,
	level:	level,
	step:	step,
	resource:	code.substr(count),
	code: this.testTransition(level, step)
	}
}//</m>getProcessor



//================
this.testTransition = function		//<m>int<a>protected<d>Check whether outline is valid
(
level,		//<p>int<d>Level to check
step		//<p>int<d>Step to check
){
if(level == this.level){
	if(step == this.step){
		if(this.step == this.K.STEP.SUBJECT) return this.K.ERROR.MISSING_PREDICATE;
		if(this.step == this.K.STEP.PREDICATE) return this.K.ERROR.MISSING_OBJECT;
		}
	else{
		if((this.step == this.K.STEP.INIT) && (step != this.K.STEP.SUBJECT)) return this.K.ERROR.MISSING_SUBJECT;
		if((this.step == this.K.STEP.SUBJECT) && (step == this.K.STEP.OBJECT)) return this.K.ERROR.MISSING_PREDICATE;
		if((this.step == this.K.STEP.PREDICATE) && (step == this.K.STEP.SUBJECT)) return this.K.ERROR.MISSING_OBJECT;
		}
	}
else{
	if(this.step == this.K.STEP.SUBJECT) return this.K.ERROR.MISSING_PREDICATE;
	if(this.step == this.K.STEP.PREDICATE) return this.K.ERROR.MISSING_OBJECT;
	if((level > this.level) && (step != this.K.STEP.PREDICATE)) return this.K.ERROR.MISSING_PREDICATE;
	}
this.level = level;
this.step = step;
return this.K.ERROR.NONE;
}//</m>testTransition



this.K.OUTLINE_CHAR ='\t';
this.K.STEP =
	{
	INIT:				-1,
	SUBJECT:			0,
	PREDICATE:			1,
	OBJECT:				2
	};



this.ASRDF_OutlineParser();
}//</c>ASRDF_OutlineParser
ASRDF_OutlineParser.prototype = new ASRDF_BaseParser;

