/*
 * The contents of this file are
 * published under the Mozilla Public License 1.1
 */
//@@@@@@@@@@@@@@@@
function ASRDF_PropertyParser		//<c><e>ASRDF_BaseParser<a>protected<d>Property line parser class
(
_propertySet		//<p>string[]<d>Properties key and value --optional
){
//================
this.ASRDF_PropertyParser = function		//<m>void<a>private<d>class constructor
(
propertySet		//<p>string[]<d>Properties key and value --optional
){
this.className	= 'ASRDF_PropertyParser';
//i12n
this.propertySet = propertySet || [];
}//</m>ASRDF_PropertyParser



//================
this.setIn = function		//<m>int<a>protected<d>Parse a source line
(
line		//<p>string<d>Source line
){
if(this.testCodeLine(line)){
	var
	/*string[]*/declaration = line.split(this.K.COMMENT.DELIMITER)[0],
	/*string[]*/keyValueSet = declaration.match(this.K.PROPERTY.DECLARATION);
	if(keyValueSet) this.propertySet[keyValueSet[1]] = this.getExtentedDeclaration(keyValueSet[2]);
	}
return this.K.ERROR.NONE;
}//</m>setIn



//================
this.getExtentedDeclaration = function		//<m>string[]<a>private<d>Extends key declarations in a declaration string
(
declaration		//<p>string<d>Declaration with keys to substitute
){
var
/*string[]*/declarationSet = declaration.split(this.K.PROPERTY.KEY_SEPARATOR);
for(var i=0,m=declarationSet.length;i<m;i++) if(declarationSet[i] in this.propertySet) declarationSet[i] = this.propertySet[declarationSet[i]];
return declarationSet.join('');
}//</m>getExtentedDeclaration



//================
this.get_propertySet = function		//<m>string<a>protected<d>Get propertySet member
(){
return this.propertySet;
}//</m>get_propertySet



this.K.PROPERTY =
	{
	DECLARATION:	/^([^\s=]+)\s*=\s*(.+)$/,
	KEY_SEPARATOR:	/\s/
	};



this.ASRDF_PropertyParser(_propertySet);
}//</c>ASRDF_PropertyParser
ASRDF_PropertyParser.prototype = new ASRDF_BaseParser;

