/*
 * The contents of this file are
 * published under the Mozilla Public License 1.1
 */
//@@@@@@@@@@@@@@@@
function ASSERT_Argument		//<c><a>public<d>Assertion argument class
(
_arg		//<p>any<d>Argument
){
//================
this.ASSERT_Argument = function		//<m>void<a>private<d>class constructor
(
arg		//<p>any<d>Argument
){
this.className	= 'ASSERT_Argument';
this.argument	= this.setArgument(arg);
}//</m>ASSERT_Argument


//================
this.setArgument = function		//<m>any<a>private<d>
(
arg		//<p>any<d>Argument
){
return this.isWithoutQuote(arg) ? arg :
	this.isArray(arg) ? this.setArrayQuoteOn(arg.concat()) :	//array copy
		this.setQuoteOn(arg);
}//</m>setArgument


//================
this.setQuoteOn = function		//<m>string<a>private<d>
(
arg		//<p>string<d>Argument
){
if(this.isString(arg)){
	arg = arg.replace(/"/g, '&quot;');
	arg = arg.replace(/'/g, '&apos;');
	}
if(typeof arg == 'function'){
	try{
		var
		/*string*/signature = arg.toString().match(/[^{]+/g);
		arg = signature[0].replace(/[\n]/g, '');
		}
	catch(e){
		arg = 'function';
		}
	}
return '"'+arg+'"';
}//</m>setQuoteOn


//================
this.setQuoteOff = function		//<m>string<a>private<d>
(
arg		//<p>any<d>Argument
){
if(this.isString(arg)){
	arg = arg.replace(/&quot;/g, '"');
	arg = arg.replace(/&apos;/g, "'");
	}
return (arg=='""') ? arg : arg.substr(1, arg.length-2);		//strip "" added by setQuoteOn
}//</m>setQuoteOff


//================
this.setArrayQuoteOn = function		//<m>any[]<a>private<d>
(
arg		//<p>any[]<d>Argument
){
for(var k in arg) if(this.isString(arg[k])) arg[k] = this.setQuoteOn(arg[k]);
return arg;
}//</m>setArrayQuoteOn


//================
this.setArrayQuoteOff = function		//<m>any[]<a>private<d>
(
arg		//<p>any[]<d>Argument
){
for(var k in arg) if(this.isString(arg[k])) arg[k] = this.setQuoteOff(arg[k]);
return arg;
}//</m>setArrayQuoteOff


//================
this.setTagOn = function		//<m>string<a>private<d>
(
arg		//<p>string<d>Argument
){
arg = arg.replace(/</g, '&lt;');
arg = arg.replace(/>/g, '&gt;');
return arg;
}//</m>setTagOn


//================
this.getArgument = function		//<m>any<a>protected<d>
(){
return this.isArray(this.argument) ? this.getArrayArgument() : this.argument;
}//</m>getArgument



//================
this.getArrayArgument = function		//<m>(boolean)string<a>private<d>
(){
return this.argument.length ? '['+this.argument+']' : false;	///empty array is false
}//</m>getArrayArgument


//================
this.getArgumentAsText = function		//<m>string<a>protected<d>
(){
if(this.isNull(this.argument)) return 'null';
if(this.isUndefined(this.argument)) return 'undefined';
if(this.isNumber(this.argument) || this.isBoolean(this.argument)) return this.argument.toString();
if(this.isString(this.argument)) return this.getStringAsText(this.argument);
if(this.isArray(this.argument)) return this.getArrayAsText(this.argument);
}//</m>getArgumentAsText


//================
this.getStringAsText = function		//<m>string<a>protected<d>
(
arg		//<p>string<d>Argument
){
return this.setTagOn(this.setQuoteOff(arg));
}//</m>getStringAsText


//================
this.getArrayAsText = function		//<m>string<a>protected<d>
(
arg		//<p>any[]<d>Argument
){
return '['+this.setArrayQuoteOff(arg)+']';
}//</m>getArrayAsText


//================
this.isWithoutQuote = function		//<m>boolean<a>private<d>
(
arg		//<p>any<d>Argument
){
return this.isNumber(arg) || this.isBoolean(arg) || this.isNull(arg) || this.isUndefined(arg);
}//</m>isWithoutQuote


//================
this.isNumber = function		//<m>boolean<a>public<d>
(
arg		//<p>any<d>Argument
){
return typeof(arg)==='number';
}//</m>isNumber


//================
this.isString = function		//<m>boolean<a>public<d>
(
arg		//<p>any<d>Argument
){
return typeof(arg)==='string';
}//</m>isString


//================
this.isUndefined = function		//<m>boolean<a>public<d>
(
arg		//<p>any<d>Argument
){
return arg===undefined;
}//</m>isUndefined


//================
this.isNull = function		//<m>boolean<a>public<d>
(
arg		//<p>any<d>Argument
){
return arg===null;
}//</m>isNull


//================
this.isBoolean = function		//<m>boolean<a>public<d>
(
arg		//<p>any<d>Argument
){
return arg===true || arg===false;
}//</m>isBoolean


//================
this.isArray = function		//<m>boolean<a>public<d>
(
arg		//<p>any<d>Argument
){
return !this.isNull(arg) && typeof(arg)==='object' && (arg.length!==undefined);
}//</m>isArray


//================
this.isObject = function		//<m>boolean<a>public<d>
(
arg		//<p>any<d>Argument
){
return !this.isNull(arg) && typeof(arg)==='object' && (arg.length===undefined);
}//</m>isObject


//================
this.isEmpty = function		//<m>boolean<a>public<d>
(
arg		//<p>any<d>Argument
){
return ((this.isString(arg) || this.isArray(arg)) && !arg.length);
}//</m>isEmpty



this.ASSERT_Argument(_arg);
}//</c>ASSERT_Argument

