/*
 * The contents of this file are
 * published under the Mozilla Public License 1.1
 */
//@@@@@@@@@@@@@@@@
function DIGEST_MD5Generator		//<c><e>DIGEST_Generator<a>public<d>MD5 encryption class
(
_hexCase,		//<p>boolean=false<d>Hexadecimal output case flag: uppercase || lowercase --optional
_charSize		//<p>int=8<d>Message character size --optional (8 bits)
){
//================
this.DIGEST_MD5Generator = function		//<m>void<a>private<d>class constructor
(
hexCase,		//<p>boolean=false<d>Hexadecimal output case flag: uppercase || lowercase --optional
charSize		//<p>int=8<d>Message character size --optional (8 bits)
){
this.prototype	= DIGEST_Generator;
this.prototype(hexCase, charSize);
this.className	= 'DIGEST_MD5Generator';
}//</m>DIGEST_MD5Generator



//================
this.getHex = function		//<m>string<a>public<d>Get digest as an hexadecimal string
(
msg		//<p>string<d>Message to digest
){
return this.testMessage(msg) ? this.getHexFromWordSet(this.getMD5(this.getWordSetFromString(msg), msg.length * this.charSize)) : '';
}//</m>getHex



//================
this.getBase64 = function		//<m>string<a>public<d>Get digest as a base-64 string
(
msg		//<p>string<d>Message to digest
){
return this.testMessage(msg) ? this.getBase64FromWordSet(this.getMD5(this.getWordSetFromString(msg), msg.length * this.charSize)) : '';
}//</m>getBase64



//================
this.getString = function		//<m>string<a>public<d>Get digest as a string
(
msg		//<p>string<d>Message to digest
){
return this.testMessage(msg) ? this.getStringFromWordSet(this.getMD5(this.getWordSetFromString(msg), msg.length * this.charSize)) : '';
}//</m>getString



//================
this.getMD5 = function		//<m>int[]<a>private<d>Core MD5 compute
(
msg,		//<p>string<d>Message to digest
size		//<p>string<d>Size of message to digest
){
msg[size >> 5] |= 0x80 << ((size) % 32);		//append padding
msg[(((size + 64) >>> 9) << 4) + 14] = size;
var
/*int*/a = STATE_0, b = STATE_1, c = STATE_2, d = STATE_3,		//registers
/*int*/aState, bState, cState, dState;							//register states
for(var i=0, m=msg.length; i<m; i+=16){
	aState = a, bState = b, cState = c, dState = d;
	a = this.getFTransform(a, b, c, d, msg[i+ 0], 7 , -680876936);
	d = this.getFTransform(d, a, b, c, msg[i+ 1], 12, -389564586);
	c = this.getFTransform(c, d, a, b, msg[i+ 2], 17,  606105819);
	b = this.getFTransform(b, c, d, a, msg[i+ 3], 22, -1044525330);
	a = this.getFTransform(a, b, c, d, msg[i+ 4], 7 , -176418897);
	d = this.getFTransform(d, a, b, c, msg[i+ 5], 12,  1200080426);
	c = this.getFTransform(c, d, a, b, msg[i+ 6], 17, -1473231341);
	b = this.getFTransform(b, c, d, a, msg[i+ 7], 22, -45705983);
	a = this.getFTransform(a, b, c, d, msg[i+ 8], 7 ,  1770035416);
	d = this.getFTransform(d, a, b, c, msg[i+ 9], 12, -1958414417);
	c = this.getFTransform(c, d, a, b, msg[i+10], 17, -42063);
	b = this.getFTransform(b, c, d, a, msg[i+11], 22, -1990404162);
	a = this.getFTransform(a, b, c, d, msg[i+12], 7 ,  1804603682);
	d = this.getFTransform(d, a, b, c, msg[i+13], 12, -40341101);
	c = this.getFTransform(c, d, a, b, msg[i+14], 17, -1502002290);
	b = this.getFTransform(b, c, d, a, msg[i+15], 22,  1236535329);
	
	a = this.getGTransform(a, b, c, d, msg[i+ 1], 5 , -165796510);
	d = this.getGTransform(d, a, b, c, msg[i+ 6], 9 , -1069501632);
	c = this.getGTransform(c, d, a, b, msg[i+11], 14,  643717713);
	b = this.getGTransform(b, c, d, a, msg[i+ 0], 20, -373897302);
	a = this.getGTransform(a, b, c, d, msg[i+ 5], 5 , -701558691);
	d = this.getGTransform(d, a, b, c, msg[i+10], 9 ,  38016083);
	c = this.getGTransform(c, d, a, b, msg[i+15], 14, -660478335);
	b = this.getGTransform(b, c, d, a, msg[i+ 4], 20, -405537848);
	a = this.getGTransform(a, b, c, d, msg[i+ 9], 5 ,  568446438);
	d = this.getGTransform(d, a, b, c, msg[i+14], 9 , -1019803690);
	c = this.getGTransform(c, d, a, b, msg[i+ 3], 14, -187363961);
	b = this.getGTransform(b, c, d, a, msg[i+ 8], 20,  1163531501);
	a = this.getGTransform(a, b, c, d, msg[i+13], 5 , -1444681467);
	d = this.getGTransform(d, a, b, c, msg[i+ 2], 9 , -51403784);
	c = this.getGTransform(c, d, a, b, msg[i+ 7], 14,  1735328473);
	b = this.getGTransform(b, c, d, a, msg[i+12], 20, -1926607734);
	
	a = this.getHTransform(a, b, c, d, msg[i+ 5], 4 , -378558);
	d = this.getHTransform(d, a, b, c, msg[i+ 8], 11, -2022574463);
	c = this.getHTransform(c, d, a, b, msg[i+11], 16,  1839030562);
	b = this.getHTransform(b, c, d, a, msg[i+14], 23, -35309556);
	a = this.getHTransform(a, b, c, d, msg[i+ 1], 4 , -1530992060);
	d = this.getHTransform(d, a, b, c, msg[i+ 4], 11,  1272893353);
	c = this.getHTransform(c, d, a, b, msg[i+ 7], 16, -155497632);
	b = this.getHTransform(b, c, d, a, msg[i+10], 23, -1094730640);
	a = this.getHTransform(a, b, c, d, msg[i+13], 4 ,  681279174);
	d = this.getHTransform(d, a, b, c, msg[i+ 0], 11, -358537222);
	c = this.getHTransform(c, d, a, b, msg[i+ 3], 16, -722521979);
	b = this.getHTransform(b, c, d, a, msg[i+ 6], 23,  76029189);
	a = this.getHTransform(a, b, c, d, msg[i+ 9], 4 , -640364487);
	d = this.getHTransform(d, a, b, c, msg[i+12], 11, -421815835);
	c = this.getHTransform(c, d, a, b, msg[i+15], 16,  530742520);
	b = this.getHTransform(b, c, d, a, msg[i+ 2], 23, -995338651);
	
	a = this.getITransform(a, b, c, d, msg[i+ 0], 6 , -198630844);
	d = this.getITransform(d, a, b, c, msg[i+ 7], 10,  1126891415);
	c = this.getITransform(c, d, a, b, msg[i+14], 15, -1416354905);
	b = this.getITransform(b, c, d, a, msg[i+ 5], 21, -57434055);
	a = this.getITransform(a, b, c, d, msg[i+12], 6 ,  1700485571);
	d = this.getITransform(d, a, b, c, msg[i+ 3], 10, -1894986606);
	c = this.getITransform(c, d, a, b, msg[i+10], 15, -1051523);
	b = this.getITransform(b, c, d, a, msg[i+ 1], 21, -2054922799);
	a = this.getITransform(a, b, c, d, msg[i+ 8], 6 ,  1873313359);
	d = this.getITransform(d, a, b, c, msg[i+15], 10, -30611744);
	c = this.getITransform(c, d, a, b, msg[i+ 6], 15, -1560198380);
	b = this.getITransform(b, c, d, a, msg[i+13], 21,  1309151649);
	a = this.getITransform(a, b, c, d, msg[i+ 4], 6 , -145523070);
	d = this.getITransform(d, a, b, c, msg[i+11], 10, -1120210379);
	c = this.getITransform(c, d, a, b, msg[i+ 2], 15,  718787259);
	b = this.getITransform(b, c, d, a, msg[i+ 9], 21, -343485551);
	
	a = this.getSafeAdd(a, aState);
	b = this.getSafeAdd(b, bState);
	c = this.getSafeAdd(c, cState);
	d = this.getSafeAdd(d, dState);
	}
return [a, b, c, d];
}//</m>getMD5



//================
this.getTransform = function		//<m>int<a>private<d>Get digest transformation
(
compute,	//<p>int<d>Computation
aReg,		//<p>int<d>A 16/64-bits register
bReg,		//<p>int<d>B 16/64-bits register
msgChar,	//<p>string<d>Message character to digest
atTab,		//<p>int<d>Sine tab index
state		//<p>int<d>Context state
){
return this.getSafeAdd(this.getBitRotation(this.getSafeAdd(this.getSafeAdd(aReg, compute), this.getSafeAdd(msgChar, state)), atTab), bReg);
}//</m>getTransform



//================
this.getFTransform = function		//<m>int<a>private<d>Get digest F transformation
(
aReg,		//<p>int<d>A 16/64-bits register
bReg,		//<p>int<d>B 16/64-bits register
cReg,		//<p>int<d>C 16/64-bits register
dReg,		//<p>int<d>A 16/64-bits register
msgChar,	//<p>string<d>Message character to digest
atTab,		//<p>int<d>Sine tab index
state		//<p>int<d>Context state
){
return this.getTransform((bReg & cReg) | ((~bReg) & dReg), aReg, bReg, msgChar, atTab, state);
}//</m>getFTransform



//================
this.getGTransform = function		//<m>int<a>private<d>Get digest F transformation
(
aReg,		//<p>int<d>A 16/64-bits register
bReg,		//<p>int<d>B 16/64-bits register
cReg,		//<p>int<d>C 16/64-bits register
dReg,		//<p>int<d>A 16/64-bits register
msgChar,	//<p>string<d>Message character to digest
atTab,		//<p>int<d>Sine tab index
state		//<p>int<d>Context state
){
return this.getTransform((bReg & dReg) | (cReg & (~dReg)), aReg, bReg, msgChar, atTab, state);
}//</m>getGTransform



//================
this.getHTransform = function		//<m>int<a>private<d>Get digest F transformation
(
aReg,		//<p>int<d>A 16/64-bits register
bReg,		//<p>int<d>B 16/64-bits register
cReg,		//<p>int<d>C 16/64-bits register
dReg,		//<p>int<d>A 16/64-bits register
msgChar,	//<p>string<d>Message character to digest
atTab,		//<p>int<d>Sine tab index
state		//<p>int<d>Context state
){
return this.getTransform(bReg ^ cReg ^ dReg, aReg, bReg, msgChar, atTab, state);
}//</m>getHTransform



//================
this.getITransform = function		//<m>int<a>private<d>Get digest F transformation
(
aReg,		//<p>int<d>A 16/64-bits register
bReg,		//<p>int<d>B 16/64-bits register
cReg,		//<p>int<d>C 16/64-bits register
dReg,		//<p>int<d>A 16/64-bits register
msgChar,	//<p>string<d>Message character to digest
atTab,		//<p>int<d>Sine tab index
state		//<p>int<d>Context state
){
return this.getTransform(cReg ^ (bReg | (~dReg)), aReg, bReg, msgChar, atTab, state);
}//</m>getITransform



//================
this.getXORDigest = function		//<m>string<a>public<d>Compute a XOR of 2 32 characters hexa digests
(
digest1,		//<p>string<d>Digest 1
digest2			//<p>string<d>Digest 2
){
var
/*string[]*/xor = '';
for(var i=0, m=4; i<m; i++) xor = this.getStringFromHex(parseInt(digest1.substring(8*i, (8*i) + 8), 16) ^ parseInt(digest2.substring(8*i, (8*i) + 8), 16)) + xor;
return xor;
}//</m>getXORDigest



const
/*int*/	STATE_0 = 0x67452301,
		STATE_2 = -STATE_0 - 1,		//0x98badcfe
		STATE_3 = 0x10325476,
		STATE_1 = -STATE_3 -1;		//0xefcdab89



this.DIGEST_MD5Generator(_hexCase, _charSize);
}//</c>DIGEST_MD5Generator<d>&
/*
Conforms to the RFC 1321.
Optimized (15% faster) from Paul Andrew Johnston's implementation (http://pajhome.org.uk/crypt/md5/index.html)
*/



var
MD5Generator = new DIGEST_MD5Generator();
//################
function MD5		//<f>string<a>public<d>Get Hex MD5 digest
(
msg		//<p>string<d>Message to digest
){
return MD5Generator.getHex(msg);
}//</f>MD5



//################
function TEST_MD5		//<f>string<a>public<d>Get Hex MD5 digest
(){
if(!__ASSERT__) return alert('__ASSERT__ not defined');
__ASSERT__.isEqual(MD5(""), 'd41d8cd98f00b204e9800998ecf8427e');
__ASSERT__.isEqual(MD5("a"), '0cc175b9c0f1b6a831c399e269772661');
__ASSERT__.isEqual(MD5("abc"), '900150983cd24fb0d6963f7d28e17f72');
__ASSERT__.isEqual(MD5("message digest"), 'f96b697d7cb7938d525a2f31aaf161d0');
__ASSERT__.isEqual(MD5("abcdefghijklmnopqrstuvwxyz"), 'c3fcd3d76192e4007dfb496cca67e13b');
__ASSERT__.isEqual(MD5("ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789"), 'd174ab98d277d9f5a5611c2c9f419d9f');
__ASSERT__.isEqual(MD5("12345678901234567890123456789012345678901234567890123456789012345678901234567890"), '57edf4a22be3c955ac49da2e2107b67a');
}//</f>TEST_MD5


