/*
 * The contents of this file are
 * published under the Mozilla Public License 1.1
 */
/*
__IMPORT__
	(
	"chrome://mozlib/content/lib/js/io/file/",
	"accessor.js",
	"locator.js",
	"descriptor.js"
	);
*/


//@@@@@@@@@@@@@@@@
function IO_file_Instantiator		//<c><a>protected<d>File instantiator class
(){
//================
this.IO_file_Instantiator = function		//<m>void<a>private<d>class constructor
(){
this.className		= 'IO_file_Instantiator';
this.setIn();
}//</m>IO_file_Instantiator



//================
this.setIn = function		//<m>void<a>private<d>Instance i12n
(){
this.errorNotifier	= new ERROR_Notifier(this.className);
this.enable			= this.K.INSTANCE_DISABLED;
this.handle			= null;
if(this.setXPCOM() == this.K.ERROR.NONE){
	this.accessor	= new IO_file_Accessor();
	this.locator	= new IO_file_Locator();
	this.descriptor	= new IO_file_Descriptor();
	}
}//</m>setIn



//================
this.setXPCOM = function		//<m>void<a>private<d>Set up XPCOM interfaces
(){
try{
	this.constructor	= XPConnector.getConstructor('nsILocalFile', 'nsILocalFile_init');
	return this.K.ERROR.NONE;
	}
catch(e){
	return this.errorNotifier.setOut(e, this.K.ERROR.SERVICE_ACCESS);
	}
}//</m>setXPCOM



//================
this.setHandle = function		//<m>void<a>private<d>Set up the handle member
(
type,			//<p>int<d>Handle type: FILE_INSTANCE || DIR_INSTANCE
path,			//<p>string<d>Path of file/dir to handle --optional (close)
permissions		//<p>int=0755<d>Permission code --optional
){
if(path){
	if(this.testProcessing('testEnable()') != this.K.ERROR.NONE) return this.K.ERROR.NO_SUCCESS;
	this.accessor.set_type(type);
	this.accessor.set_permissions(permissions);
	this.accessor.handle	=
	this.locator.handle		=
	this.descriptor.handle	=
	this.handler.handle		=
	this.handle				= new this.constructor(path);
	}
else{
	if(this.testProcessing('testHandle()') != this.K.ERROR.NONE) return this.K.ERROR.NO_SUCCESS;
	delete this.handle;
	}
return this.K.ERROR.NONE;
}//</m>setHandle



//================
this.get_handle = function		//<m>Object<a>public<d>Get the handle member
(){
return this.handle;
}//</m>get_handle



//================
this.getClone = function		//<m>void<a>public<d>Get a clone of this handle
(){
return this.handle.clone();
}//</m>getClone



//================
this.getStat = function		//<m>string<a>public<d>Get handled file/dir information
(){
return {
	entity:		this.testEntity(),
	file:		this.testFile(),
	dir:		this.testDirectory(),
	link:		this.testSymbolic(),
	hidden:		this.testHidden(),
	read:		this.testReadable(),
	write:		this.testWritable(),
	exec:		this.testExecutable(),
	permissions:this.getPermissions(),
	url:		this.getUrl(),
	path:		this.getPath(),
	leaf:		this.getLeaf(),
	name:		this.getName(),
	extension:	this.getExtension(),
	target:		this.getLinkTarget(),
	size:		this.getSize(),
	date:		this.getDateModified(),
	time:		(new Date).toLocaleString()
	};
}//</m>getStat



//================
this.getPermissions = function		//<m>string<a>public<d>Get date of handled file/dir
(){
return this.testAccess() ? this.accessor.get_permissions().toString(8) : '';
}//</m>getPermissions



//================
this.getSize = function		//<m>string<a>public<d>Get date of handled file/dir
(){
return this.testAccess() ? this.descriptor.getSize() : '';
}//</m>getSize



//================
this.getDateModified = function		//<m>string<a>public<d>Get date of handled file/dir
(){
return this.testAccess() ? this.descriptor.getDate() : '';
}//</m>getDateModified



//================
this.getUrl = function		//<m>string<a>public<d>Get an URL about the handled file/dir
(){
return this.testAccess() ? this.locator.getUrl() : '';
}//</m>getUrl



//================
this.getPath = function		//<m>string<a>public<d>Get an URL about the handled file/dir
(){
return this.testAccess() ? this.locator.getUrl(this.locator.K.URL_PATH) : '';
}//</m>getPath



//================
this.getLeaf = function		//<m>string<a>public<d>Get an URL about the handled file/dir
(){
return this.testAccess() ? this.locator.getUrl(this.locator.K.URL_LEAF) : '';
}//</m>getLeaf



//================
this.getName = function		//<m>string<a>public<d>Get an URL about the handled file/dir
(){
return this.testAccess() ? this.locator.getUrl(this.locator.K.URL_NAME) : '';
}//</m>getName



//================
this.getExtension = function		//<m>string<a>public<d>Get an URL about the handled file/dir
(){
return this.testAccess() ? this.locator.getUrl(this.locator.K.URL_EXTENSION) : '';
}//</m>getExtension



//================
this.getLinkTarget = function		//<m>string<a>public<d>Get the URL pointed to by the handled file/dir symbolic link
(){
return this.testAccess() ? this.locator.getLinkTarget() : '';	
}//</m>getLinkTarget



//================
this.getParentDir = function		//<m>IO_file_dirInstantiator<a>public<d>Get the handled file/dir parent directory instance
(){
if(!this.testAccess()) return null;
var
/*Object*/parent = this.locator.getParent();
if(!parent) return null;				//parent is volume root dir
var
/*IO_file_dirInstantiator*/ioDir = new IO_file_dirInstantiator(),
/*int*/instantiation = ioDir.set_handle(parent.path	/*, 0755*/);
return (instantiation == this.K.ERROR.NONE) ? ioDir : null;	
}//</m>getParentDir



//================
this.testEnable = function		//<m>boolean<a>private<d>Check whether enable member is set
(){
return this.enable;
}//</m>testEnable



//================
this.testHandle = function		//<m>boolean<a>private<d>Check whether handle member is set
(){
return (this.handle != undefined);
}//</m>testHandle



//================
this.testProcessing = function		//<m>boolean<a>private<d>Check the conditions of the requested processing
(
//condition arguments		//<p>string[]<d>Conditions to satisfy
){
var
/*string*/condition;
try{
	for(var i=0,m=arguments.length;i<m;i++){
		condition = arguments[i];
		if(!(eval('this.' + condition))) throw condition + ': IS FALSE';
		}
	return this.K.ERROR.NONE;
	}
catch(e){
	return this.errorNotifier.setOut('[testProcessing] ' + e, this.K.ERROR.NO_PROCESSING);
	}
}//</m>testProcessing



//================
this.testAccess = function		//<m>boolean<a>private<d>Check whether handle references an existing file/dir
(){
return this.testProcessing('testHandle()', 'accessor.testEntity()') == this.K.ERROR.NONE;
}//</m>testAccess



//================
this.testEntity = function		//<m>boolean<a>public<d>Check whether the handled file/dir exists
(){
return this.testAccess();
}//</m>testEntity



//================
this.testType = function		//<m>boolean<a>public<d>Check the type (file, dir, link, hidden) of the handled file/dir
(
type		//<p>string<d>Type of entity to test
){
return (this.testAccess() && (this.testProcessing('accessor.testEntity("' + type + '")') == this.K.ERROR.NONE));
}//</m>testType



//================
this.testFile = function		//<m>boolean<a>public<d>Check whether the handled file/dir is a file
(){
return this.testType('file');
}//</m>testFile



//================
this.testDirectory = function		//<m>boolean<a>public<d>Check whether the handled file/dir is a directory
(){
return this.testType('dir');
}//</m>testDirectory



//================
this.testSymbolic = function		//<m>boolean<a>public<d>Check whether the handled file/dir is a symbolic link
(){
return this.testType('link');
}//</m>testSymbolic



//================
this.testHidden = function		//<m>boolean<a>public<d>Check whether the handled file/dir is hidden
(){
return this.testType('hidden');
}//</m>testHidden



//================
this.testPermissions = function		//<m>boolean<a>public<d>Check whether the handled file/dir has requested permission
(
permission		//<p>string<d>Type of permission to test
){
return (this.testAccess() && (this.testProcessing('accessor.testMode("' + permission + '")') == this.K.ERROR.NONE));
}//</m>testPermissions



//================
this.testReadable = function		//<m>boolean<a>public<d>Check whether the handled file/dir is readable
(){
return this.testPermissions('r');
}//</m>testReadable



//================
this.testWritable = function		//<m>boolean<a>public<d>Check whether the handled file/dir is writable
(){
return this.testPermissions('w');
}//</m>testWritable



//================
this.testExecutable = function		//<m>boolean<a>public<d>Check whether the handled file/dir is executable
(){
return this.testPermissions('x');
}//</m>testExecutable



this.K =
	{
	INSTANCE_ENABLED:			true,
	INSTANCE_DISABLED:			false,
	FILE_INSTANCE:				0,
	DIR_INSTANCE:				1,
	
	READONLY_ACCESS:			0444,
	WRITEONLY_ACCESS:			0222,

	ERROR:
		{
		//NON FATAL
		NONE:					0,
		NO_SUCCESS:				1,
		NO_PROCESSING:			2,

		//FATAL
		SERVICE_ACCESS:			-1,
		PROCESS_ACCESS:			-2,
		TARGET_URL_ENTITY:		-3,
		TARGET_URL_DIR_ENTITY:	-4,
		FATAL:					0xFF		//end of error codes
		}
	};



this.IO_file_Instantiator();
}//</c>IO_file_Instantiator<d>&
/*
This class acts as a base class for file and directory subclasses with specific methods
adopting a "fa�ade" design pattern to access specialized subcomponent classes:
	accessor,
	descriptor,
	locator,
	handler
*/


