/*
 * The contents of this file are
 * Copyright (C) 2003 ID EST. All Rights Reserved.
 */
//@@@@@@@@@@@@@@@@
function PROMPT_Controller		//<c>abstract<a>protected<d>Prompt alert controller class
(){
//================
this.PROMPT_Controller = function		//<m>void<a>private<d>class constructor
(){
this.className	= 'PROMPT_Controller';
}//</m>PROMPT_Controller



//================
this.setOut = function		//<m>void<a>public<d>Output dialog
(
title,			//<p>string<d>Prompt title
label,			//<p>string<d>Alert message
checkLabel,		//<p>string<d>Checkbox label
inputSet		//<p>Object<d>Input descriptor
){
if(!this.testPrompter()) return;
this.title			= title;
this.label			= label;
this.checkLabel		= checkLabel || null;
this.setOutputCheckbox();
if(!inputSet) return this.setOutAlert();
this.inputSet		= inputSet;
switch(inputSet.mode){
	case 1:			//CONFIRM_MODE
		this.setOutConfirm();
		break;
	case 2:			//PROMPT_MODE
		this.setOutPrompt();
		break;
	default:		//SELECT_MODE inputSet is an Array, so no mode property
		this.setOutSelection();
		break;
	}	//---switch
}//</m>setOut



//================
this.setOutAlert = function		//<m>void<a>public<d>Output an alert dialog
(){
var
/*string*/method = this.checkLabel ? 'alertCheck' : 'alert';
this.prompter[method](this.title, this.label, this.checkLabel, this.output.checkbox);
//return undefined;
}//</m>setOutAlert



//================
this.setOutConfirm = function		//<m>void<a>public<d>Output a confirmation dialog
(){
if(this.inputSet.buttonSet){
	if(!this.inputSet.labelSet) this.inputSet.labelSet = [];		//just to avoid referencing error
	this.output.accept = this.prompter['confirmEx'](this.title, this.label,
		this.getConfirmFlag(), this.inputSet.labelSet[0] || '', this.inputSet.labelSet[1] || '', this.inputSet.labelSet[2] || '', 
		this.checkLabel, this.output.checkbox);	
	}
else{
	var
	/*string*/method = this.checkLabel ? 'confirmCheck' : 'confirm';
	this.output.accept = this.prompter[method](this.title, this.label, this.checkLabel, this.output.checkbox);
	}
return this.getAccept();
}//</m>setOutConfirm



//================
this.setOutPrompt = function		//<m>void<a>public<d>Output prompt dialog
(){
this.output.prompt.value = this.inputSet.prompt || '';
this.output.upass.value = this.inputSet.upass || '';
if(this.inputSet.prompt && this.inputSet.upass){
	this.output.accept = this.prompter['promptUsernameAndPassword'](this.title, this.label, this.output.prompt, this.output.upass, this.checkLabel, this.output.checkbox);
	}
else{
	if(this.inputSet.upass){
		this.output.accept = this.prompter['promptPassword'](this.title, this.label, this.output.upass, this.checkLabel, this.output.checkbox);	
		}
	else{
		this.output.accept = this.prompter['prompt'](this.title, this.label, this.output.prompt, this.checkLabel, this.output.checkbox);
		}
	}
if(!this.output.accept) this.output.prompt.value = '';
if(!this.output.accept) this.output.upass.value = '';
return this.getAccept();
}//</m>setOutPrompt



//================
this.setOutSelection = function		//<m>void<a>public<d>Output dialog
(){
this.output.accept = this.prompter['select'](this.title, this.label, this.inputSet.length, this.inputSet, this.output.selection);
this.output.selection.key = this.output.accept ? this.inputSet[this.output.selection.value] : '';
return this.getAccept();
}//</m>setOutSelection



//================
this.setOutputCheckbox = function		//<m>void<a>public<d>Synchronise output checkbox with input checkbox
(){
this.output.checkbox.value = this.input.checkbox.value;
}//</m>setOutputCheckbox



//================
this.getConfirmFlag = function		//<m>void<a>private<d>Compute confirmation dialog button flag
(){
var
/*string*/buttonFlag,
/*int*/flag = 0;
for(var i=0,j=0,m=this.inputSet.buttonSet.length;i<m;i++,j+=8){
	buttonFlag = this.inputSet.buttonSet[i];
	if(buttonFlag in this.prompter) flag += this.prompter[buttonFlag] * (1 << j);
	//Stdout.setOut('flag: %Tbutton: %N', this.prompter[buttonFlag], (1 << j));
	}	//---for
return flag;
}//</m>getConfirmFlag



this.PROMPT_Controller();
}//</c>PROMPT_Controller
PROMPT_Controller.prototype = new PROMPT_Instantiator;




