/*
 * The contents of this file are
 * published under the Mozilla Public License 1.1
 */
//@@@@@@@@@@@@@@@@
function XPCOM_ScriptLoader		//<c><a>public<d>Javascript file loader class
(){
//================
this.XPCOM_ScriptLoader = function		//<m>void<a>private<d>class constructor
(){
this.className	= 'XPCOM_ScriptLoader';
//i12n
this.errorNotifier = new ERROR_Notifier(this.className);
this.loadSet = (this.setXPCOM() == this.K.ERROR.NONE) ? [] : null;
this.reloading = false;
}//</m>XPCOM_ScriptLoader



//================
this.setXPCOM = function		//<m>void<a>private<d>SetUp RDF service interface
(){
try{
	var
	/*string*/component	= '@mozilla.org/moz/jssubscript-loader;1',
	/*string*/iface		= 'mozIJSSubScriptLoader';
	this.SubScriptLoader = Components.classes[component].createInstance(Components.interfaces[iface]);
	return this.K.ERROR.NONE;
	}
catch(e){
	this.SubScriptLoader = null;
	return this.errorNotifier.setOut(e, this.K.ERROR.SERVICE_ACCESS);
	}
}//</m>setXPCOM



//================
this.setLoad = function		//<m>boolean<a>public<d>Load a collection of script files
(
urlSet			//<p>string[]<d>Url of JS files to load
){
if(!this.testService()) return this.K.ERROR.NO_SUCCESS;		//skip any load if service is not available
var
/*string*/url, baseUrl;
try{
	baseUrl = this.getBaseUrl(urlSet[this.K.BASE_URL]);
	if(urlSet.length == 1) urlSet = [0, this.K.DEFAULT_PACKAGE];
	for(var i=1,m=urlSet.length;i<m;i++){
		url = baseUrl + urlSet[i];
		if(this.reloading || this.testNotLoaded(url)){
			this.SubScriptLoader.loadSubScript(url);
			this.setLoaded(url);
			//dump('XPCOM_ScriptLoader: ' + url + '\n');
			}
		}
	return this.K.ERROR.NONE;
	}
catch(e){
	return this.errorNotifier.setOut(e + ' ' + url, this.K.ERROR.LOAD_FAILURE);
	}
}//</m>setLoad<d>&
/*
urlSet argument can be a single directory path. Then this directory MUST contain a file, named as DEFAULT_PACKAGE, defining its own import.
*/



//================
this.set_reloading = function		//<m>boolean<a>public<d>Set up reloading member to force reload
(
reloading		//<p>boolean<d>Reloading flag
){
var
/*boolean*/flag = this.reloading;
this.reloading = reloading;
return flag;
}//</m>set_reloading



//================
this.setLoaded = function		//<m>void<a>private<d>Mark a script file url in the loadSet member after successfull loading
(
url		//<p>string<d>Url of the loaded script file
){
this.loadSet[url] = true;
}//</m>setLoaded



//================
this.getBaseUrl = function		//<m>string<a>private<d>Get the base URL for loading
(
baseUrl		//<p>string<d>Base URL for loading
){
return (this.testScheme(baseUrl) ? '' : this.K.LOCAL_URL_SCHEME) + baseUrl;
}//</m>getBaseUrl<d>&
/*
If baseUrl doesn't starts with an available scheme, LOCAL_URL_SCHEME is prepended to the baseUrl
*/



//================
this.testNotLoaded = function		//<m>boolean<a>private<d>Check whether the script file has not been loaded already
(
url		//<p>string<d>Url of the script file to load
){
return !(url in this.loadSet);
}//</m>testNotLoaded



//================
this.testService = function		//<m>boolean<a>private<d>Check whether service has been initialized
(){
return this.SubScriptLoader != null;
}//</m>testService



//================
this.testScheme = function		//<m>boolean<a>private<d>Check whether the URL starts with an accepted scheme
(
url		//<p>string<d>URL
){
return url.match(this.K.URL_SCHEME_PATTERN) != null;
}//</m>testScheme



this.K =
	{
	mozIJSSubScriptLoader:		'@mozilla.org/moz/jssubscript-loader;1',
	
	BASE_URL:					0,			//index
	DEFAULT_PACKAGE:			'_package_.js',
	URL_SCHEME_PATTERN:			/^(file)|(chrome):\/\//,
	LOCAL_URL_SCHEME:			'file://',

	ERROR:
		{
		SERVICE_FAILURE:		'XPCOM mozIJSSubScriptLoader service access failed',
		
		//NON FATAL
		NONE:					0,
		NO_SUCCESS:				1,

		//FATAL
		SERVICE_ACCESS:			-1,
		LOAD_FAILURE:			-2,
		FATAL:					0xFF		//end of error codes
		}
	};



this.XPCOM_ScriptLoader();
}//</c>XPCOM_ScriptLoader



var
/*XPCOM_ScriptLoader*/	ScriptLoader = new XPCOM_ScriptLoader();


//################
function __IMPORT__		//<f>void<a>public<d>XPCOM_ScriptLoader instance setLoad method wrapper
(
//arguments		//<p>string[]<d>Directory path plus file names of files to load
){
ScriptLoader.setLoad(arguments);
}//</f>__IMPORT__<d>&
/*
Argument 0: directory path
Argument 1-n: name of files in the directory
*/

